unit Unit1;

 (* Programmation : Jean Claude Meier,  images : Bruno Doug

    (* To easily realize shows on computers with .bmp pictures          *)
    (* The soft displays pictures named from 1000.bmp+1000.txt          *)
    (* then 1001.bmp+1001.txt and so on (max 9999.bmp+9999.txt          *)
    (* without lack otherwise we go back to 0000.                  *)
    (* ALT-C displays/hides the command panel (forward, backward, pause *)
    (* Marvellous effects on pictures display are due to           *)
    (* TFxImage component from Chris Kokkos (found on Torry and         *)
    (* joined here) which must be correctly installed as usual          *)

    (* fr *)
    (* Pour raliser trs facilement un diaporama sur ordinateur.                 *)
    (* Affiche image + texte de 1000.bmp+1000.Txt  .....bmp+ .....txt (max=9999) *)
    (* il ne faut pas de trou sinon on repart  0.                                *)
    (* ALT-C pour afficher/cacher le panel de config (avant,arrire, pause)       *)
    (* Les somptueux effets  l'apparition des images sont l'oeuvre du composant  *)
    (* TFxImage de Chris Kokkos (joint  l'archive) qui devra tre install       *)


interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Controls,
  Forms, Dialogs, FxImage, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    FxLabel1: TFxLabel;
    FxImage1: TFxImage;
    Timer1: TTimer;
    Panel1: TPanel;
    ScrollBar1: TScrollBar;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn2: TBitBtn;
    Timer2: TTimer;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    procedure FormActivate(Sender: TObject);
    procedure affiche_image(le_no : integer);
    procedure affiche_texte(le_no : integer);
    procedure gere(le_no : integer; augmente_no:boolean);
    procedure Timer1Timer(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure AppMessage(var msg: TMsg; var handled: boolean);
    procedure FormResize(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PlaceMouse(x, y: word);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;


var
  Form1: TForm1;

implementation

{$R *.DFM}
Const decal = 1000;
      top_pause : integer = 0;
var
  no : integer;
(* Place mouse cursor in (x,y)      *)
(* Place le curseur souris en (x,y) *)
procedure TForm1.PlaceMouse(x, y: word);
var
  tp: TPoint;
begin
  tp := ClientToScreen(point(x, y));
  SetCursorPos(tp.x, tp.y);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  WindowState := wsMaximized;
  Randomize;
  no := 0;
  ScrollBar1.Position := 25000;
  Application.OnMessage := AppMessage;
end;
{TRUE = Disable the screensaver.}
(* dsactive l'conomiseur d'cran *)
procedure TForm1.AppMessage(var msg: TMsg; var handled: boolean);
begin
  if (msg.message = wm_SysCommand) and (msg.wParam = sc_ScreenSave) then
    handled := true;
end;
(* shows picture centered *)
procedure TForm1.affiche_image(le_no : integer);
begin
  fxImage1.Visible := false;
  if not Panel1.Visible then
  PlaceMouse(ClientHeight+20,ClientWidth+20);
  if FileExists(IntToStr(le_no+decal)+'.bmp') then
  begin
    fxImage1.Picture.loadfromfile(inttostr(le_no+decal)+'.bmp');
    (* centre l'image *)
    fxImage1.Top := (ClientHeight-fxImage1.Height) div 2;
    fxImage1.Left := (ClientWidth-fxImage1.Width) div 2;
    fxImage1.BoxWidth := 3;
    fxImage1.Effect := Random(41)+1;
    fxImage1.Visible := true;
  end
  else                                      (* is lacking *)
  MessageDlg('image '+IntToStr(le_no+decal)+'.bmp manquante',mtError,[mbok],0);
end;

procedure TForm1.Affiche_Texte(le_no : integer);
begin
  if FileExists(IntToStr(le_no+decal)+'.txt') then
  begin
    Memo1.Lines.LoadFromFile(IntToStr(le_no+decal)+'.txt');
    fxLabel1.Caption := Memo1.Text;
  end
  else
  fxLabel1.Caption := '';
end;

procedure TForm1.Gere(le_no : integer; augmente_no:boolean);
begin
  Affiche_Image(le_no);
  Affiche_Texte(le_no);
  if augmente_no then
  begin
    if FileExists(IntToStr(no+1+decal)+'.bmp')
    then inc(no)
    else no := 0;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Gere(no,true);
end;
(* display time *)
(* temps d'animation *)
procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  Timer1.Interval := 30000-ScrollBar1.Position;
  Timer1Timer(Sender);
  Timer1.Enabled:= true;
end;
(* backward *)
(* on recule *)
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  ScrollBar1.Position := 1000; (* vitesse mini *)
  if no > 0 Then dec(no,1);
  Gere(no,false);
  Timer1.Enabled:= true;
end;
(* forward *)
(* on avance *)
procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  if FileExists(IntToStr(no+1+decal)+'.bmp')  Then inc(no)
  else no := 0;
  Gere(no,false);
  Timer1.Enabled:= true;
end;
(* break *)
(* pause *)
procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  Timer1.Enabled:= not Timer1.Enabled;
  if Timer1.Enabled then
  begin
    Timer1Timer(Sender);
    Timer2.Enabled := false;
  end
  else
  begin
    Timer2.Enabled := true;
    top_pause := 0;
  end;
end;
procedure TForm1.FormResize(Sender: TObject);
begin
  Panel1.Left := ClientWidth-Panel1.Width-5;
  Panel1.Top := ClientHeight-Panel1.Height-5;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
const delai = 3;   (* se remet en route automatiquement aprs 3 min de pause *)
begin              (* loop again after 3 minutes of break *)
   if top_pause < delai-1 then inc(top_pause)
   else
   begin
     Timer1.Enabled := true;
     top_pause := 0;
     Timer2.Enabled := false;
   end;
end;
(* hides/shows the command panel *)
(* cache/affiche le panel de commande *)
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin   (* Alt-c *)
   if ((ssAlt in shift) and (key = $43)) then
   Panel1.Visible := not Panel1.Visible;
end;
(* The end *)
(* Quitter *)
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Close;
end;
(* copyright while ending *)
(* Message en quittant *)
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MessageDlg('Programmation : Jean Claude Meier'#13#10#13#10+
             'Photos             :  Bruno Doug', mtInformation,
      [mbOk], 0);
end;

end.


